/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.dbazza.pageSync;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import javax.swing.JOptionPane;
import org.netbeans.modules.php.project.environment.PhpEnvironment;
import org.openide.filesystems.FileObject;
import org.openide.loaders.DataObject;
import org.openide.nodes.Node;
import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;
import org.openide.util.actions.CookieAction;

public final class pageSync extends CookieAction {

    protected void performAction(Node[] activatedNodes) {
        DataObject dataObject = activatedNodes[0].getLookup().lookup(DataObject.class);
        FileObject f = dataObject.getPrimaryFile();

        String php_executable;
        String current_path = f.toString().substring(0, f.toString().lastIndexOf(f.getNameExt()) - 1);
        String current_page_name = f.getName();
        String outputString;

        PhpEnvironment phpEnv =  org.netbeans.modules.php.project.environment.PhpEnvironment.get();
        php_executable = phpEnv.getAnyPhpInterpreter();

        //org.netbeans.modules.php.editor.PHPCodeCompletion codice;

        outputString = "";

        try
        {
            Process pageSyncProcess = Runtime.getRuntime().exec(php_executable + " ./build/classes/org/dbazza/pageSync/pageSync.php " + current_path + " " + current_page_name);

            BufferedReader input = new BufferedReader(new InputStreamReader(pageSyncProcess.getInputStream()));
            String line;

            outputString = "";
            while ((line = input.readLine()) != null)
            {
                outputString = outputString + line;
            }

            input.close();

        }
        catch( Exception e)
        {
            if(e.getMessage() != null)
            {
                JOptionPane.showMessageDialog(null,e.getMessage(), "Error",JOptionPane.ERROR_MESSAGE);
            }
            else
            {
                JOptionPane.showMessageDialog(null,"Prado page/php synchronization error.", "Error", JOptionPane.ERROR_MESSAGE);
            }
        }

        if(outputString.equals(""))
        {
            JOptionPane.showMessageDialog(null,"Prado page/php synchronization completed.", "Messaggio", JOptionPane.INFORMATION_MESSAGE);
        }
        else
        {
            JOptionPane.showMessageDialog(null,outputString, "Error", JOptionPane.ERROR_MESSAGE);
        }
    }

    protected int mode() {
        return CookieAction.MODE_EXACTLY_ONE;
    }

    public String getName() {
        return NbBundle.getMessage(pageSync.class, "CTL_pageSync");
    }

    protected Class[] cookieClasses() {
        return new Class[]{DataObject.class};
    }

    @Override
    protected void initialize() {
        super.initialize();
        // see org.openide.util.actions.SystemAction.iconResource() Javadoc for more details
        putValue("noIconInMenu", Boolean.TRUE);
    }

    public HelpCtx getHelpCtx() {
        return HelpCtx.DEFAULT_HELP;
    }

    @Override
    protected boolean asynchronous() {
        return false;
    }
    
}

